<?php

namespace STM\Match\Action\Team;

use \Exception;
use STM\StmFactory;

/**
 * Test class for MatchTeamActionValidator.
 * Generated by PHPUnit on 2012-07-11 at 17:29:34.
 * @group match_action
 */
class MatchTeamActionValidatorTest extends \PHPUnit_Framework_TestCase {

    private $valid_structure;

    protected function setUp() {
        $this->valid_structure = array(
            'match' => StmFactory::find()->Match->findById (5),
            'match_action' => StmFactory::find()->MatchAction->findById(1), 
            'value_home' => '111*', 
            'value_away' => '22*2',
        );
    }

    public function testCheck_create() {        
        // argument must be array with keys match, match_action, value_home, value_away
        $this->assert_bad_arguments('checkCreate', null);
        $this->assert_bad_arguments('checkCreate', new Exception());
        // match must be instanceof Match
        $this->assert_bad_arguments('checkCreate', $this->get_modified_structure('match', null));
        // action must be instanceof MatchAction
        $this->assert_bad_arguments('checkCreate', $this->get_modified_structure('match_action', new Exception()));
        // value_home must be string <1, 20>
        $this->assert_bad_arguments('checkCreate', $this->get_modified_structure('value_away', '1234567890123456789012345'));
        // value_away must be string <1, 20>
        $this->assert_bad_arguments('checkCreate', $this->get_modified_structure('value_home', ''));
        // match & action must be unique
        if ($this->valid_structure['match'] && $this->valid_structure['match_action']) {
            if (StmFactory::find()->MatchTeamAction->findById($this->valid_structure['match'], $this->valid_structure['match_action'])) {
                $this->assert_bad_arguments('checkCreate', $this->valid_structure);
            } else {
                parent::assertTrue(MatchTeamActionValidator::checkCreate($this->valid_structure));
            }
        }
    }

    public function testCheck_update() {
        // compared object must be set
        $this->assert_bad_arguments('checkUpdate', array('value_home' => '5','value_away' => '10'));        
        $team_actions = StmFactory::find()->MatchTeamAction->findByMatch(StmFactory::find()->Match->findById (5));
        if ($team_actions) {
            foreach ($team_actions as $action) {
                MatchTeamActionValidator::setMatchTeamAction($action);                            
                // value must be non empty and <1, 20>
                $this->assert_bad_arguments('checkUpdate', array('value_home' => '','value_away' => '1234567890123456789012345'));
                // at least one value must be different
                $arr = $action->toArray();
                $this->assert_bad_arguments('checkUpdate', array('value_home' => $arr['value_home'],'value_away' => $arr['value_away']));
                MatchTeamActionValidator::resetMatchTeamAction();
            }
        }
    }

    private function get_modified_structure($key, $new_value) {
        $attributes = $this->valid_structure;
        $attributes[$key] = $new_value;
        return $attributes;
    }
    
    private function assert_bad_arguments($method, $data) {
        MatchTeamActionValidator::init();
        parent::assertFalse(MatchTeamActionValidator::$method($data));
        MatchTeamActionValidator::init();
    }

}

?>